/***********************************************************
 * $Id: fancysaxschemavalidator.h 1420 2014-12-31 23:15:57Z fancylibs $
 *
 * FancySAX
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYSAXSCHEMAVALIDATOR_H_
#define FANCYSAXSCHEMAVALIDATOR_H_

#include <fancyobject.h>
#include <fancysax.h>

namespace Fancy {
namespace SAX {

/**
 * A schema validator instance to be injected to a @c Reader instance.
 */
class FANCYSAX_API SchemaValidator: public virtual Fancy::Object {

public:
    typedef Fancy::ObjPtr<SchemaValidator> ptr_t;

    /**
     * The URL of the schema.
     */
    virtual std::string getUrl() const = 0;

    /**
     * @return Whether the parser document was valid regarding the schema.
     */
    virtual bool isSchemaValid() const = 0;

protected:
    SchemaValidator();
    virtual ~SchemaValidator();
};

}
}

#endif /* FANCYSAXSCHEMAVALIDATOR_H_ */
